import java.util.*;

class LetIn extends Expr
{
	private Hashtable mini_hash; 
	private Env mini_env;
	private Expr e;

	public LetIn (Hashtable mini_hash, Expr e)
	{
		this.mini_hash = mini_hash;
		this.e = e;
	}

	public String expr_str (Env envp) throws Exception
	{
		int first = 1;
		Expr tmp_obj;
		String tmp_str;
		StringBuffer sb = new StringBuffer ("(let ");
                
		for (Enumeration e = mini_hash.keys ();
		     e.hasMoreElements();) {
			tmp_str = (String)e.nextElement();
			tmp_obj = (Expr)mini_hash.get(tmp_str);
			if (first == 1)
				first = 0;
			else
				sb.append(" and ");
			sb.append(tmp_str + " = " + tmp_obj);
		}

		return (sb + " in " + e.expr_str() + ")");
	}

	public String expr_str ()
	{
		return("indefini - ne doit pas etre utilis.");
	}

	public Type typer (Env envp) throws Exception
	{
		Env my_env;

		if (mini_env == null)
			createEnv(envp);

		my_env = envp.MergeWithEnv(mini_env);
		return (this.e.typer(my_env));
	}

	public Valeur evaluer (Env envp) throws Exception
	{
		Env my_env;

		if (mini_env == null)
			createEnv(envp);

		my_env = envp.MergeWithEnv (mini_env);
		return (this.e.evaluer(my_env));
	}

	public void createEnv(Env envp) throws Exception
	{
		Expr tmp_obj;
		String tmp_str;

		this.mini_env = new Env();

		for (Enumeration e = mini_hash.keys ();
		     e.hasMoreElements();) {
			tmp_str = (String)e.nextElement();
			tmp_obj = (Expr)mini_hash.get(tmp_str);
			mini_env.ajt(tmp_str, tmp_obj, envp);
		}
	}

}
