/**
* La classe representant une valeur booleene.
*
* @version 0.1, 06/05/2003
* @see Valeur
* @see ValeurException
* @see java.lang.String 
* @see java.lang.Object
*/
public class VBool extends Valeur
{
	private boolean value;

	/**
	* Constructeur de la classe VBool
	*
	* @param Un boolean pour initialiser la valeur de la classe.
	*/
	public VBool (boolean v)
	{
		this.value = v ;
	}

	/**
	* Retourne un objet String representant la valeur contenue dans la classe
	*
	* @return Un objet String contenant soit "true", soit "false".
	*/
	public String val_str ()
	{
		if (value == true) {
			return ("true");
		} else {
			return ("false");
		}
	}

	/**
	* Retourne la valeur booleene contenue dans cette classe.
	* 
	* @return La valeur booleene contenue dans la classe.
	*/
	public boolean valeur_bool () throws ValeurException
	{
		return (value);
	}

	/**
	* Eleve une exception de type ValeurException: Un boolean n'a pas de valeur
	* entiere.
	*
	* @return Rien.
	* @exception ValeurException
	*            Un booleen n'a pas de valeur entiere.
	*/
	public int valeur_int () throws ValeurException
	{
		/* Exception */
		throw new ValeurException ("Un booleen n'a pas de valeur entiere.\n");
	}

}
