/**
* La classe representant un booleen.
*
* @version 0.1, 06/05/2003
* @see Type
* @see java.lang.String
* @see java.lang.Object 
*/
public class TBool extends Type
{
	/**
	* Renvoit une String "bool".
	*
	* @return Un objet String contenant "bool".
	*/
	public String type_str ()
	{
		return ("bool");
	}

	/**
	* Teste si l'objet de type Type est une instance de TBool
	*
	* @param L'objet de type Type
	* @return Un boolean: true si l'objet a tester est de type TBool, sinon false.
	*/
	public static boolean isTBool (Type o)
	{
		if (o instanceof TBool) {
			return true;
		} else {
			return false;
		}
	}
}
