/**
* La classe representant un entier.
*
* @version 0.1, 06/05/2003
* @see Type
* @see java.lang.Object
* @see java.lang.String
*/
public class TEntier extends Type
{
	/**
	* Renvoit une String contenant "int"
	*
	* @return Un objet String contenant "int"
	*/
	public String type_str ()
	{
		return ("int");
	}

	/**
	* Teste si l'objet de type Type est une instante de TEntier.
	*
	* @param L'objet de type Type
	* @return Un boolean: true si l'objet a tester est de type TEntier, sinon false.
	*/
	public static boolean isTEntier (Type o)
	{
		if (o instanceof TEntier) {
			return true;
		} else {
			return false;
		}
	}
}
