/**
* Le type de classe abstraite representant un Type.
*
* @version 0.1, 06/05/2003
* @see java.io.Serializable
* @see java.lang.Object
* @see java.lang.String
* @see TBool
* @see TEntier
* @see TFonction
*/

public abstract class Type implements java.io.Serializable 
{
	/**
	* Retourne une chaine de caracteres representant le type.
	*
	* @return La chaine de caracteres.
	*/
	abstract String type_str ();

	/**
	* Retourne une chaine de caracteres representant le type
	*
	* @return La chaine de caracteres.
	*/
	public String toString ()
	{
		return (this.type_str());
	}

	/**
	* Affiche la chaine de caracteres representant le type.
	*/
	public void afficher_type ()
	{
		System.out.println (this.type_str());
	}
}
