import java.util.*;

public class main
{
  public static void main (String [] argv)
  {
    /* Nous avons un environnement */
    Env mon_env;
    /* Pour les LetIn, nous avons besoin d'un environnement que l'on passera */
    Hashtable letin_env, letin_env_2;

    Session s1, s2, s3, s4, s5;

    System.out.println("Session 1: Creation");
    s1 = new Session();
    s1.ajouter_ins(new Declaration ("a", new Vrai()));
    s1.ajouter_ins(new Declaration ("b", new Faux()));
    s1.ajouter_ins(new Egal(new Variable("a"), new Variable("b")));
    s1.ajouter_ins(new If(new Variable("a"), new Constante(1), new Constante(2)));
    s1.ajouter_ins(new If(new Variable("b"), new Constante(1), new Constante(2)));
    s1.ajouter_ins(new Declaration("a", new Constante(10)));
    s1.ajouter_ins(new Declaration("x", new Constante (6)));
    s1.ajouter_ins(new Declaration("u", new Fonction("x", new TEntier(), new Addition(new Variable("x"), new Variable("a")))));
    s1.ajouter_ins(new Declaration ("x", new Constante(7)));
    s1.ajouter_ins(new Variable("u"));
    s1.ajouter_ins(new Application(new Variable("u"), new Constante(4)));
    s1.ajouter_ins(new Application(new Variable("u"), new Variable("a")));

    letin_env = new Hashtable();
    letin_env.put("a", new Constante(1));
    letin_env.put("b", new Variable("u"));
    letin_env.put("c", new Variable("x"));
    s1.ajouter_ins(new LetIn(letin_env, new Variable("u")));
    s1.ajouter_ins(new LetIn(letin_env, new Application (new Variable("b"), new Variable("a"))));
    letin_env.put("d", new Variable("b"));
    s1.ajouter_ins(new LetIn(letin_env, new Variable ("d")));
 
    letin_env = new Hashtable();
    letin_env.put("a", new Addition(new Constante(1), new Constante(2)));
    letin_env.put("b", new Ou(new Vrai(), new Faux()));
    letin_env.put("c", new Fonction ("x", new TEntier(), new Addition(new Variable("x"), new Variable("a"))));
    s1.ajouter_ins(new LetIn(letin_env, new If(new Variable("b"), new Application(new Variable("c"), new Variable("a")), new Oppose(new Variable("a")))));

    System.out.println("Session 1: Execution");
    mon_env = s1.executer();

    System.out.println("Session 2: Creation");
    s2 = new Session();

    letin_env = new Hashtable();
    letin_env.put("carre", new Fonction("y", new TBool(), new Produit(new Variable("y"), new Variable("y"))));
    letin_env.put("div_2", new Fonction("y", new TEntier(), new Division(new Variable("y"), new Constante(2))));
    letin_env.put("pair", new Fonction("y", new TEntier(), new Egal(new Modulo(new Variable("y"), new Constante(2)), new Constante(0))));
    s2.ajouter_ins(new LetIn(letin_env, new If(new Application(new Variable("pair"), new Constante(5)), new Application(new Variable("carre"), new Constante(5)), new Application(new Variable("div_2"), new Constante(5)))));

    letin_env = new Hashtable();
    letin_env.put("carre", new Fonction("y", new TEntier(), new Produit(new Variable("y"), new Variable("y"))));
    letin_env.put("div_2", new Fonction("y", new TEntier(), new Division(new Variable("y"), new Constante(2))));
    letin_env.put("pair", new Fonction("y", new TEntier(), new Egal(new Modulo(new Variable("y"), new Constante(2)), new Constante(0))));
    s2.ajouter_ins(new LetIn(letin_env, new If(new Non(new Application(new Variable("pair"), new Constante(5))), new Application(new Variable("carre"), new Constante(5)), new Application(new Variable("div_2"), new Constante(5)))));

    s2.ajouter_ins(new Variable("carre"));
    s2.ajouter_ins(new Variable("div_2"));
    s2.ajouter_ins(new Variable("pair"));
    s2.ajouter_ins(new Declaration("a", new Constante(2)));
    s2.ajouter_ins(new Variable("a"));

    s2.ajouter_ins(new Declaration("carre", new Fonction("x", new TEntier(), new Produit(new Variable("x"), new Variable("x")))));
    s2.ajouter_ins(new Declaration("div_2", new Fonction("x", new TEntier(), new Division(new Variable("x"), new Variable("a")))));
    s2.ajouter_ins(new Application(new Variable("div_2"), new Constante(35)));
    s2.ajouter_ins(new Declaration("pair", new Fonction("x", new TEntier(), new Egal(new Modulo(new Variable("x"), new Constante(2)), new Constante(0)))));
    s2.ajouter_ins(new Declaration("a", new Constante(8)));
    s2.ajouter_ins(new Variable("carre"));
    s2.ajouter_ins(new Variable("div_2"));
    s2.ajouter_ins(new Variable("pair"));
    s2.ajouter_ins(new Variable("a"));
    s2.ajouter_ins(new Application(new Variable("div_2"), new Constante(35)));
    s2.ajouter_ins(new Declaration("f", new Fonction("x", new TEntier(), new If(new Non(new Application(new Variable("pair"), new Variable("x"))), new Application(new Variable("carre"), new Variable("x")), new Application(new Variable("div_2"), new Variable("x"))))));
    s2.ajouter_ins(new Application(new Variable("f"), new Constante(24)));
    s2.ajouter_ins(new Application(new Variable("f"), new Constante(-7)));
    System.out.println("Session 2: Execution");
    mon_env = s2.executer();

    System.out.println("Session 3: Creation");
    s3 = new Session();
    s3.ajouter_ins(new Declaration("a", new Soustraction(new Constante(3), new Constante(15))));
    s3.ajouter_ins(new Declaration("b", new Constante(7)));
    s3.ajouter_ins(new If(new InfEgal(new Variable("a"), new Variable("b")), new Constante(1), new Vrai()));
    s3.ajouter_ins(new Application(new Fonction("x", new TBool(), new If(new Variable("x"), new Constante(1), new Constante(0))), new Constante(2)));
    s3.ajouter_ins(new Application(new Fonction("x", new TBool(), new If(new Variable("x"), new Constante(1), new Constante(0))), new Non(new Et(new Vrai(), new Faux()))));

    letin_env = new Hashtable();
    letin_env.put("a", new Vrai());
    letin_env.put("b", new Constante(13));
    letin_env.put("a", new Constante(-3));
    letin_env.put("c", new Constante(9));
    s3.ajouter_ins(new LetIn(letin_env, new Addition(new Variable("a"), new Addition(new Variable("b"), new Variable("c")))));

    letin_env = new Hashtable();
    letin_env.put("c", new Modulo(new Constante(3425), new Constante(31)));
    letin_env.put("d", new Produit(new Variable("c"), new Constante(-2)));
    s3.ajouter_ins(new LetIn(letin_env, new Variable("d"))); 

    letin_env = new Hashtable();
    letin_env_2 = new Hashtable();
    letin_env.put("c", new Modulo(new Constante(3425), new Constante(31)));
    letin_env_2.put("d", new Produit(new Variable("c"), new Constante(-2)));
    s3.ajouter_ins(new LetIn(letin_env, new LetIn(letin_env_2, new Variable("d"))));

    s3.ajouter_ins(new Variable("c"));
    s3.ajouter_ins(new Variable("d"));

    letin_env = new Hashtable();
    letin_env.put("a", new Division(new Variable("a"), new Variable("b")));
    s3.ajouter_ins(new LetIn(letin_env, new Variable("a")));
    s3.ajouter_ins(new Variable("a"));

    s3.ajouter_ins(new Declaration("comp_0", new Fonction("z", new TEntier(), new If(new Inf(new Variable("z"), new Constante(0)), new Constante(-1), new If(new Sup(new Variable("z"), new Constante(0)), new Constante(1), new Constante(0))))));

    s3.ajouter_ins(new Application(new Variable("comp_0"), new Constante(2003)));
    s3.ajouter_ins(new Application(new Variable("a"), new Variable("b")));
    s3.ajouter_ins(new Application(new Variable("comp_0"), new Variable("a")));
    s3.ajouter_ins(new Application(new Variable("comp_0"), new Variable("b")));


    System.out.println("Session 3: Execution");
    mon_env = s3.executer();

    System.out.println("Session 4: Creation");
    s4 = new Session();

    s4.ajouter_ins(new Declaration("val_abs", new Fonction("n", new TEntier(), new If(new SupEgal(new Variable("n"), new Constante(0)), new Variable("n"), new Oppose(new Variable("n"))))));

    s4.ajouter_ins(new Application(new Variable("val_abs"), new Constante(0)));
    s4.ajouter_ins(new Application(new Variable("val_abs"), new Constante(-56)));

    letin_env = new Hashtable();
    letin_env.put("carre", new Fonction("x", new TEntier(), new Produit(new Variable("x"), new Variable("x"))));
    s4.ajouter_ins(new Declaration("puissance_4", new Fonction("y", new TEntier(), new LetIn(letin_env, new Produit(new Application(new Variable("carre"), new Variable("y")), new Application(new Variable("carre"), new Variable("y")))))));
    s4.ajouter_ins(new Variable("carre"));
    s4.ajouter_ins(new Application(new Variable("puissance_4"), new Constante(4)));
    letin_env = new Hashtable();
    letin_env.put("f", new Fonction("x", new TBool(), new If(new Egal(new Variable("x"), new Vrai()), new Constante(1), new Constante(0))));
    letin_env.put("g", new Fonction("x", new TEntier(), new If(new Different(new Variable("x"), new Constante(0)), new Vrai(), new Faux())));
    s4.ajouter_ins(new Declaration("id", new Fonction("x", new TBool(), new LetIn(letin_env, new Application(new Variable("g"), new Application(new Variable("f"), new Variable("x")))))));
    s4.ajouter_ins(new Variable("f"));
    s4.ajouter_ins(new Variable("g"));
    s4.ajouter_ins(new Application(new Variable("id"), new Vrai()));
    s4.ajouter_ins(new Application(new Variable("id"), new Faux()));
    letin_env = new Hashtable();
    letin_env.put("a", new Constante(8));
    s4.ajouter_ins(new Declaration("mult", new LetIn(letin_env, new Fonction("x", new TEntier(), new Produit(new Variable("x"), new Variable("a")))))); 
    s4.ajouter_ins(new Variable("a"));
    s4.ajouter_ins(new Application(new Variable("mult"), new Constante(14)));
    s4.ajouter_ins(new Different(new Vrai(), new Constante(3)));
    s4.ajouter_ins(new Inf(new Vrai(), new Vrai()));

    System.out.println("Session 4: Execution");
    mon_env = s4.executer();

    System.out.println("Session 5: Creation");
    s5 = new Session();
    s5.ajouter_ins(new Declaration("divisible_par_n", new Fonction("n", new TEntier(), new Fonction("x", new TEntier(), new Egal(new Modulo(new Variable("x"), new Variable("n")), new Constante(0))))));
    s5.ajouter_ins(new Application(new Application(new Variable("divisible_par_n"), new Constante(9)), new Constante(45)));
    s5.ajouter_ins(new Application(new Application(new Variable("divisible_par_n"), new Constante(11)), new Constante(45)));
    s5.ajouter_ins(new Declaration("divisible_par_7", new Application(new Variable("divisible_par_n"), new Constante(7))));
    s5.ajouter_ins(new Application(new Variable("divisible_par_7"), new Constante(49)));
    s5.ajouter_ins(new Application(new Variable("divisible_par_7"), new Constante(20)));
    s5.ajouter_ins(new Variable("divisible_par_n"));
    s5.ajouter_ins(new Declaration("b1", new Application(new Variable("divisible_par_7"), new Constante(49))));
    s5.ajouter_ins(new Declaration("b2", new Application(new Variable("divisible_par_7"), new Constante(20))));
    s5.ajouter_ins(new Variable("b1"));
    s5.ajouter_ins(new Variable("b2"));

    System.out.println("Session 5: Execution");
    mon_env = s5.executer();
  }
}
